
/* nmemonic operation code table */
struct t_opcode base_inst[57] = {
	{NULL,"ADC",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0x61,0},
	{NULL,"AND",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0x21,0},
	{NULL,"ASL",ACC|ZP|ZP_X|ABS|ABS_X,0x02,0},
	{NULL,"BCC",CLASS2,0x90,0},
	{NULL,"BCS",CLASS2,0xb0,0},
	{NULL,"BEQ",CLASS2,0xf0,0},
	{NULL,"BIT",IMM|ZP|ZP_X|ABS|ABS_X,0x00,2},
	{NULL,"BMI",CLASS2,0x30,0},
	{NULL,"BNE",CLASS2,0xd0,0},
	{NULL,"BPL",CLASS2,0x10,0},
	{NULL,"BRK",CLASS1,0x00,0},
	{NULL,"BVC",CLASS2,0x50,0},
	{NULL,"BVS",CLASS2,0x70,0},
	{NULL,"CLC",CLASS1,0x18,0},
	{NULL,"CLD",CLASS1,0xd8,0},
	{NULL,"CLI",CLASS1,0x58,0},
	{NULL,"CLV",CLASS1,0xb8,0},
	{NULL,"CMP",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0xC1,0},
	{NULL,"CPX",IMM|ZP|ABS,0xE0,1},
	{NULL,"CPY",IMM|ZP|ABS,0xC0,1},
	{NULL,"DEC",ACC|ZP|ZP_X|ABS|ABS_X,0x00,3},
	{NULL,"DEX",CLASS1,0xCA,0},
	{NULL,"DEY",CLASS1,0x88,0},
	{NULL,"EOR",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0x41,0},
	{NULL,"INC",ACC|ZP|ZP_X|ABS|ABS_X,0x00,4},
	{NULL,"INX",CLASS1,0xE8,0},
	{NULL,"INY",CLASS1,0xC8,0},
	{NULL,"JMP",ABS|ABS_IND|ABS_IND_X,0x40,0},
	{NULL,"JSR",ABS,0x14,0},
	{NULL,"LDA",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0xa1,0},
	{NULL,"LDX",IMM|ZP|ZP_Y|ABS|ABS_Y,0xa2,1},
	{NULL,"LDY",IMM|ZP|ZP_X|ABS|ABS_X,0xa0,1},
	{NULL,"LSR",ACC|ZP|ZP_X|ABS|ABS_X,0x42,0},
	{NULL,"NOP",CLASS1,0xea,0},
	{NULL,"ORA",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0x01,0},
	{NULL,"PHA",CLASS1,0x48,0},
	{NULL,"PHP",CLASS1,0x08,0},
	{NULL,"PLA",CLASS1,0x68,0},
	{NULL,"PLP",CLASS1,0x28,0},
	{NULL,"ROL",ACC|ZP|ZP_X|ABS|ABS_X,0x22,0},
	{NULL,"ROR",ACC|ZP|ZP_X|ABS|ABS_X,0x62,0},
	{NULL,"RTI",CLASS1,0x40,0},
	{NULL,"RTS",CLASS1,0x60,0},
	{NULL,"SBC",IMM|ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0xe1,0},
	{NULL,"SEC",CLASS1,0x38,0},
	{NULL,"SED",CLASS1,0xf8,0},
	{NULL,"SEI",CLASS1,0x78,0},
	{NULL,"STA",ZP|ZP_X|ZP_IND|ZP_IND_X|ZP_IND_Y|ABS|ABS_X|ABS_Y,0x81,0},
	{NULL,"STX",ZP|ZP_Y|ABS,0x82,0},
	{NULL,"STY",ZP|ZP_X|ABS,0x80,0},
	{NULL,"TAX",CLASS1,0xaa,0},
	{NULL,"TAY",CLASS1,0xa8,0},
	{NULL,"TSX",CLASS1,0xba,0},
	{NULL,"TXA",CLASS1,0x8a,0},
	{NULL,"TXS",CLASS1,0x9a,0},
	{NULL,"TYA",CLASS1,0x98,0},
	{NULL,NULL,0,0,0}
};

/* pseudo operation code table */
struct t_opcode base_pseudo[62] = {
	{NULL,"=",PSEUDO,P_EQU,0},

	{NULL,"BANK",PSEUDO,P_BANK,0},
	{NULL,"BSS",PSEUDO,P_BSS,S_BSS},
	{NULL,"CODE",PSEUDO,P_CODE,S_CODE},
	{NULL,"DATA",PSEUDO,P_DATA,S_DATA},
	{NULL,"DB",PSEUDO,P_DB,0},
	{NULL,"DEFCHR",PSEUDO,P_DEFCHR,0},
	{NULL,"DW",PSEUDO,P_DW,0},
	{NULL,"DS",PSEUDO,P_DS,0},
	{NULL,"ELSE",PSEUDO,P_ELSE,0},
	{NULL,"ENDIF",PSEUDO,P_ENDIF,0},
	{NULL,"ENDM",PSEUDO,P_ENDM,0},
	{NULL,"EQU",PSEUDO,P_EQU,0},
	{NULL,"FAIL",PSEUDO,P_FAIL,0},
	{NULL,"FUNC",PSEUDO,P_FUNC,0},
	{NULL,"IF",PSEUDO,P_IF,0},
	{NULL,"IFDEF",PSEUDO,P_IFDEF,1},
	{NULL,"IFNDEF",PSEUDO,P_IFNDEF,0},
	{NULL,"INCBIN",PSEUDO,P_INCBIN,0},
	{NULL,"INCLUDE",PSEUDO,P_INCLUDE,0},
	{NULL,"INCCHR",PSEUDO,P_INCCHR,0xEA},
	{NULL,"LIST",PSEUDO,P_LIST,0},
	{NULL,"MACRO",PSEUDO,P_MACRO,0},
	{NULL,"MLIST",PSEUDO,P_MLIST,0},
	{NULL,"NOLIST",PSEUDO,P_NOLIST,0},
	{NULL,"NOMLIST",PSEUDO,P_NOMLIST,0},
	{NULL,"ORG",PSEUDO,P_ORG,0},
	{NULL,"PAGE",PSEUDO,P_PAGE,0},
	{NULL,"RSSET",PSEUDO,P_RSSET,0},
	{NULL,"RS",PSEUDO,P_RS,0},
	{NULL,"ZP",PSEUDO,P_ZP,S_ZP},

	{NULL,".BANK",PSEUDO,P_BANK,0},
	{NULL,".BSS",PSEUDO,P_BSS,S_BSS},
	{NULL,".CODE",PSEUDO,P_CODE,S_CODE},
	{NULL,".DATA",PSEUDO,P_DATA,S_DATA},
	{NULL,".DB",PSEUDO,P_DB,0},
	{NULL,".DEFCHR",PSEUDO,P_DEFCHR,0},
	{NULL,".DW",PSEUDO,P_DW,0},
	{NULL,".DS",PSEUDO,P_DS,0},
	{NULL,".ELSE",PSEUDO,P_ELSE,0},
	{NULL,".ENDIF",PSEUDO,P_ENDIF,0},
	{NULL,".ENDM",PSEUDO,P_ENDM,0},
	{NULL,".EQU",PSEUDO,P_EQU,0},
	{NULL,".FAIL",PSEUDO,P_FAIL,0},
	{NULL,".FUNC",PSEUDO,P_FUNC,0},
	{NULL,".IF",PSEUDO,P_IF,0},
	{NULL,".IFDEF",PSEUDO,P_IFDEF,1},
	{NULL,".IFNDEF",PSEUDO,P_IFNDEF,0},
	{NULL,".INCBIN",PSEUDO,P_INCBIN,0},
	{NULL,".INCLUDE",PSEUDO,P_INCLUDE,0},
	{NULL,".INCCHR",PSEUDO,P_INCCHR,0xEA},
	{NULL,".LIST",PSEUDO,P_LIST,0},
	{NULL,".MACRO",PSEUDO,P_MACRO,0},
	{NULL,".MLIST",PSEUDO,P_MLIST,0},
	{NULL,".NOLIST",PSEUDO,P_NOLIST,0},
	{NULL,".NOMLIST",PSEUDO,P_NOMLIST,0},
	{NULL,".ORG",PSEUDO,P_ORG,0},
	{NULL,".PAGE",PSEUDO,P_PAGE,0},
	{NULL,".RSSET",PSEUDO,P_RSSET,0},
	{NULL,".RS",PSEUDO,P_RS,0},
	{NULL,".ZP",PSEUDO,P_ZP,S_ZP},
	{NULL,NULL,0,0,0}
};

