
/* pce specific instructions */
struct t_opcode pce_inst[82] = {
	{NULL,"BBR", CLASS10,0x0F,0},
	{NULL,"BBR0",CLASS5, 0x0F,0}, {NULL,"BBR1",CLASS5,0x1f,0},
	{NULL,"BBR2",CLASS5, 0x2F,0}, {NULL,"BBR3",CLASS5,0x3f,0},
	{NULL,"BBR4",CLASS5, 0x4F,0}, {NULL,"BBR5",CLASS5,0x5f,0},
	{NULL,"BBR6",CLASS5, 0x6F,0}, {NULL,"BBR7",CLASS5,0x7f,0},
	{NULL,"BBS", CLASS10,0x8F,0},
	{NULL,"BBS0",CLASS5, 0x8F,0}, {NULL,"BBS1",CLASS5,0x9f,0},
	{NULL,"BBS2",CLASS5, 0xAF,0}, {NULL,"BBS3",CLASS5,0xbf,0},
	{NULL,"BBS4",CLASS5, 0xCF,0}, {NULL,"BBS5",CLASS5,0xdf,0},
	{NULL,"BBS6",CLASS5, 0xEF,0}, {NULL,"BBS7",CLASS5,0xff,0},
	{NULL,"BRA", CLASS2, 0x80,0},
	{NULL,"BSR", CLASS2, 0x44,0},
	{NULL,"CLA", CLASS1, 0x62,0},
	{NULL,"CLX", CLASS1, 0x82,0},
	{NULL,"CLY", CLASS1, 0xC2,0},
	{NULL,"CSH", CLASS1, 0xD4,0},
	{NULL,"CSL", CLASS1, 0x54,0},
	{NULL,"PHX", CLASS1, 0xDA,0},
	{NULL,"PHY", CLASS1, 0x5A,0},
	{NULL,"PLX", CLASS1, 0xFA,0},
	{NULL,"PLY", CLASS1, 0x7A,0},
	{NULL,"RMB", CLASS9, 0x07,0},
	{NULL,"RMB0",ZP, 0x03,0}, {NULL,"RMB1",ZP,0x13,0},
	{NULL,"RMB2",ZP, 0x23,0}, {NULL,"RMB3",ZP,0x33,0},
	{NULL,"RMB4",ZP, 0x43,0}, {NULL,"RMB5",ZP,0x53,0},
	{NULL,"RMB6",ZP, 0x63,0}, {NULL,"RMB7",ZP,0x73,0},
	{NULL,"SAX", CLASS1, 0x22,0},
	{NULL,"SAY", CLASS1, 0x42,0},
	{NULL,"SET", CLASS1, 0xF4,0},
	{NULL,"SMB", CLASS9, 0x87,0},
	{NULL,"SMB0",ZP, 0x83,0}, {NULL,"SMB1",ZP,0x93,0},
	{NULL,"SMB2",ZP, 0xA3,0}, {NULL,"SMB3",ZP,0xB3,0},
	{NULL,"SMB4",ZP, 0xC3,0}, {NULL,"SMB5",ZP,0xD3,0},
	{NULL,"SMB6",ZP, 0xE3,0}, {NULL,"SMB7",ZP,0xF3,0},
	{NULL,"ST0", IMM,0x03,1},
	{NULL,"ST1", IMM,0x13,1},
	{NULL,"ST2", IMM,0x23,1},
	{NULL,"STZ", ZP|ZP_X|ABS|ABS_X,0x00,5},
	{NULL,"SXY", CLASS1,0x02,0},
	{NULL,"TAI", CLASS6,0xF3,0},
	{NULL,"TAM", CLASS8,0x53,0},
	{NULL,"TAM0",CLASS3,0x53,0x01}, {NULL,"TAM1",CLASS3,0x53,0x02},
	{NULL,"TAM2",CLASS3,0x53,0x04}, {NULL,"TAM3",CLASS3,0x53,0x08},
	{NULL,"TAM4",CLASS3,0x53,0x10}, {NULL,"TAM5",CLASS3,0x53,0x20},
	{NULL,"TAM6",CLASS3,0x53,0x40}, {NULL,"TAM7",CLASS3,0x53,0x80},
	{NULL,"TDD", CLASS6,0xC3,0},
	{NULL,"TIA", CLASS6,0xE3,0},
	{NULL,"TII", CLASS6,0x73,0},
	{NULL,"TIN", CLASS6,0xD3,0},
	{NULL,"TMA", CLASS8,0x43,0},
	{NULL,"TMA0",CLASS3,0x43,0x01}, {NULL,"TMA1",CLASS3,0x43,0x02},
	{NULL,"TMA2",CLASS3,0x43,0x04}, {NULL,"TMA3",CLASS3,0x43,0x08},
	{NULL,"TMA4",CLASS3,0x43,0x10}, {NULL,"TMA5",CLASS3,0x43,0x20},
	{NULL,"TMA6",CLASS3,0x43,0x40}, {NULL,"TMA7",CLASS3,0x43,0x80},
	{NULL,"TRB", ZP|ABS,0x10,0},
	{NULL,"TSB", ZP|ABS,0x00,0},
	{NULL,"TST", CLASS7,0x00,0},
	{NULL,NULL,0,0,0}
};

/* pce specific pseudos */
struct t_opcode pce_pseudo[15] = {
	{NULL,"DEFPAL", PSEUDO,P_DEFPAL,0},
	{NULL,"DEFSPR", PSEUDO,P_DEFSPR,0},
	{NULL,"INCBAT", PSEUDO,P_INCBAT,0xD5},
	{NULL,"INCSPR", PSEUDO,P_INCSPR,0xEA},
	{NULL,"INCPAL", PSEUDO,P_INCPAL,0xF8},
	{NULL,"PAL",    PSEUDO,P_PAL,0},
	{NULL,"VRAM",   PSEUDO,P_VRAM,0},

	{NULL,".DEFPAL",PSEUDO,P_DEFPAL,0},
	{NULL,".DEFSPR",PSEUDO,P_DEFSPR,0},
	{NULL,".INCBAT",PSEUDO,P_INCBAT,0xD5},
	{NULL,".INCSPR",PSEUDO,P_INCSPR,0xEA},
	{NULL,".INCPAL",PSEUDO,P_INCPAL,0xF8},
	{NULL,".PAL",PSEUDO,P_PAL,0},
	{NULL,".VRAM",PSEUDO,P_VRAM,0},
	{NULL,NULL,0,0,0}
};

