
/* ASSEMBLE.C */
void assemble(void);
int  oplook(int *idx);
void addinst(struct t_opcode *optbl);
int  check_eol(int *ip);
void do_if(int *ip);
void do_else(int *ip);
void do_endif(int *ip);
void do_ifdef(int *ip);

/* CODE.C */
void class1(int *ip);
void class2(int *ip);
void class3(int *ip);
void class4(int *ip);
void class5(int *ip);
void class6(int *ip);
void class7(int *ip);
void class8(int *ip);
void class9(int *ip);
void class10(int *ip);
int  getoperand(int *ip, int flag, int last_char);
int  getstring(int *ip, char *buffer, int size);

/* COMMAND.C */
void pseudo(int *ip);
void do_db(int *ip);
void do_dw(int *ip);
void do_equ(int *ip);
void do_page(int *ip);
void do_org(int *ip);
void do_bank(int *ip);
void do_incbin(int *ip);
void do_include(int *ip);
void do_rsset(int *ip);
void do_rs(int *ip);
void do_ds(int *ip);
void do_fail(int *ip);
void do_section(int *ip);
void do_pcx(int *ip);
void do_incchr(int n, unsigned int *arg);

/* EXPR.C */
int  evaluate(int *ip, char flag);
int  push_val(int type);
int  getsym(void);
int  check_keyword(void);
int  push_op(int op);
int  do_op(void);
int  check_func_args(char *func_name);

/* FUNC.C */
void do_func(int *ip);
int  func_look(void);
int  func_install(int ip);
int  func_extract(int ip);
int  func_getargs(void);

/* INPUT.C */
void  init_path(void);
int   readline(void);
int   open_input(char *name);
int   close_input(void);
FILE *open_file(char *name, char *mode);

/* MACRO.C */
void   do_macro(int *ip);
void   do_endm(int *ip);
struct t_macro *macro_look(int *ip);
int    macro_getargs(int ip);
int    macro_install(void);
int    macro_getargtype(char *arg);

/* MAIN.C */
int  main(int argc, char **argv);
void show_seg_usage(void);

/* NES.C */
void init_machine(void);
void write_header(FILE *f, int banks);
int  pack_8x8_tile(void *data, int format, int offset);

/* NES_CMD.C */
void do_defchr(int *ip);
void do_inesprg(int *ip);
void do_ineschr(int *ip);
void do_inesmap(int *ip);
void do_inesmir(int *ip);

/* OUTPUT.C */
void println(void);
void clearln(void);
void error(char *stptr);
void fatal_error(char *stptr);
void loadlc(int offset, int f);
void putbyte(int offset, int data);
void putword(int offset, int data);
void putbuffer(void *data, int size);
void hexcon(int digit, int num);

/* PCE.C */
void init_machine(void);
void write_header(FILE *f, int banks);
int  pack_8x8_tile(void *data, int format, int offset);
int  pack_16x16_tile(void *data, int format, int offset);

/* PCE_CMD.C */
void do_defpal(int *ip);
void do_defchr(int *ip);
void do_defspr(int *ip);
void do_incbat(int n, unsigned int *arg);
void do_incpal(int n, unsigned int *arg);
void do_incspr(int n, unsigned int *arg);
void do_vram(int *ip);
void do_pal(int *ip);

/* PCX.C */
int  check_args(int *arg, int n, int *a, int *b, int *c, int *d, int size);
int  load_pcx(char *name);
void decode_256(FILE *f, int w, int h);
void decode_16(FILE *f, int w, int h);

/* SYMBOL.C */
int symhash(void);
int colsym(int *ip);
struct t_symbol *stlook(int flag);
struct t_symbol *stinstal(int hash, int type);
int labldef(int lval, int flag);

