#include "debug.c"
#include "joy.c"
#include "gfx.c"

#define INIT_POS 0x2D0

main()
{

  int direction, ball_pos, ball_y, ball_x;
  int racket1, racket2, score1, score2;

  init_debug_mode();

  direction = -63; /* Initial direction, upper right */

  racket1 = 0x140; /* Initial positions of rackets */
  racket2 = 0x15F;

  ball_pos = INIT_POS; /* Initial position of the ball */

  score1 = 0; /* Initial scores */
  score2 = 0;

  for(;;)
  {

    putdigit(CHAR_BLK, ball_pos); /* Erase the ball */

    ball_y = ball_pos / 0x40;      /* Compute coordinates of the ball */
    ball_x = ball_pos - 0x40 * ball_y; /* for easier rebound handling */

    if (ball_y <= 1)  /* We've reached the top of the screen */
      direction += 0x80;
    else
      if (ball_y >= 28) /* and there, the bottom of the screen */
        direction -= 0x80;

    if (ball_x >= 31) /* We've reached the right border */
      {
        direction -= 2;
        if ((ball_pos<racket2) ||
            (ball_pos>racket2 + 0x80)) /* The right player missed the ball */
          {
            ball_pos = INIT_POS;
            score1++;
          }
      }
    else
      if (ball_x <= 0) /* We've reached the left border */
      {
        direction +=2;
        if ((ball_pos<racket1) ||
            (ball_pos>racket1 + 0x80)) /* The left player missed the ball */
          {
            ball_pos = INIT_POS;
            score2++;
          }
      }

    ball_pos += direction;            /* Updates the ball position */
    putdigit(0x0, ball_pos);          /* Display the ball */

    putdigit(CHAR_BLK, racket1);          /* Erase the left racket */
    putdigit(CHAR_BLK, racket1 + 0x40);
    putdigit(CHAR_BLK, racket1 + 0x80);

    if (joy(0) & JOY_DOWN == JOY_DOWN) /* Left player moves down */
     {
      if (racket1 < 0x680) /* We can go down */
        racket1 += 0x40;
     }
    else if (joy(0) & JOY_UP == JOY_UP) /* Left player moves up */
      if (racket1 >= 0x80) /* We can go up */
        racket1 -= 0x40;

    putdigit(0x1, racket1);        /* Display the left racket */
    putdigit(0x1, racket1 + 0x40);
    putdigit(0x1, racket1 + 0x80);

    putdigit(CHAR_BLK, racket2);       /* Erase the right racket */
    putdigit(CHAR_BLK, racket2 + 0x40);
    putdigit(CHAR_BLK, racket2 + 0x80);

    if (joy(1) & JOY_DOWN == JOY_DOWN) /* Right player moves down */
     {
      if (racket2 < 0x680) /* We can go down */
        racket2 += 0x40;
     }
    else if (joy(1) & JOY_UP == JOY_UP) /* Right player moves up */
      if (racket2 >= 0x80) /* We can go up */
        racket2 -= 0x40;

    putdigit(0x2, racket2);       /* Display the right racket */
    putdigit(0x2, racket2 + 0x40);
    putdigit(0x2, racket2 + 0x80);

    putnumber(score1, 0x85);      /* Display left player's score */
    putnumber(score2, 0x9A);      /* Display right player's score */

    /* Here, we wait for screen refreshing so that we can see what we did */
    vsync(1);

  }

}
