;
; MACROS USED BY SMALL-C (v0.2 - 06/nov/97)
;

__ldbp	.macro
	 lda	[\1]
	 tax
	.endm

__stbps	.macro
       __stw	<__temp
       __ldwp	 __stack
       __stw	<__ptr
       __ldw	<__temp
	 sax         
	 sta	[__ptr]
	 sax
       __addmi	2,__stack
	.endm

__ldw	.macro
	 ldx	\1
	 lda	\1+1
	.endm

__ldwp	.macro
	 lda	[\1]
	 tax
	 ldy	#1
	 lda	[\1],Y
	.endm

__ldwi	.macro
	 ldx	#low(\1)
	 lda	#high(\1)
	.endm

__stw	.macro
	 stx	\1
	 sta	\1+1
	.endm

__stwp	.macro
	 sax
	 sta	[\1]
	 sax
	 ldy	#1
	 sta	[\1],Y
	.endm

__stwps	.macro
       __stw	<__temp
       __ldwp	 __stack
       __stw	<__ptr
       __ldw	<__temp
       __stwp	 __ptr
       __addmi	2,__stack
	.endm

__pushw	.macro
       __submi	2,__stack
         sax
	 sta	[__stack]
	 sax
	 ldy	#1
	 sta	[__stack],Y
	.endm

__popw	.macro
	 lda	[__stack]
	 tax
	 ldy	#1
	 lda	[__stack],Y
       __addmi	2,__stack
	.endm

__calls	.macro
       __popw
       __stw	__ptr
	 ldy	#high(.x\@)
	 phy
	 ldy	#low(.x\@)
	 phy
	 jmp	[__ptr]
.x\@:
	.endm

__swapw	.macro
	 pha
	 ldy	#1
	 lda	[__stack],Y
	 sta	<__temp
	 lda	[__stack]
	 sax
	 sta	[__stack]
	 pla
	 sta	[__stack],Y
	 lda	<__temp
	.endm


; TODO : check if we need pha/pla or not
__tstw	.macro
         ; pha
	 stx	<__temp
	 ora	<__temp
	 ; pla
	.endm

__aslw	.macro
	 sax
	 asl	A
	 sax
	 rol	A
	.endm

__asls	.macro
	 asl	[__stack]
	 ldy	#1
	 rol	[__stack],Y
	.endm

__asrw	.macro
	 tay
	 lsr	A
	 sax
	 ror	A
	 sax
	 sta	<__temp
	 tya
	 and	#$80
	 ora	<__temp
	.endm

__extw	.macro
	 cly
	 txa
	 bpl	.x\@
	 ldy	#$FF
.x\@:	 tya
	.endm

__comw	.macro
	 sax
	 eor	#$FF
	 sax
	 eor	#$FF
	.endm

__negw	.macro
	 sax
	 eor	#$FF
	 clc
	 adc	#1
	 sax
	 eor	#$FF
	 adc	#0
	.endm

__boolw	.macro
	 stx	<__temp
	 ora	<__temp
	 clx
	 beq	.x\@
	 inx
.x\@	 cla
	.endm

__notw	.macro
	 stx	<__temp
	 ora	<__temp
	 clx
	 bne	.x\@
	 inx
.x\@	 cla
	.endm

__addwi	.macro
	 clc
	 sax
	 adc	#low(\1)
	 sax
	 adc	#high(\1)
	.endm	

__addmi	.macro
	 pha
	 clc
	 lda	<\2
	 adc	#low(\1)
	 sta	<\2
	 lda	<\2+1
	 adc	#high(\1)
	 sta	<\2+1
	 pla
	.endm	

__subwi	.macro
	 sec
	 sax
	 sbc	#low(\1)
	 sax
	 sbc	#high(\1)
	.endm	

__submi	.macro
	 pha
	 sec
	 lda	<\2
	 sbc	#low(\1)
	 sta	<\2
	 lda	<\2+1
	 sbc	#high(\1)
	 sta	<\2+1
	 pla
	.endm	

__addws	.macro
        sax
        ldy #1
        clc
        adc     [__stack]
        sax
        adc     [__stack],Y
        __addmi 2, __stack
	.endm

__subws	.macro

;        Almost works, we could try to finish it in order to make code more
;        efficient and smaller
;
;        sax
;        ldy #1
;        clc
;        sbc     [__stack]
;        sax
;        sbc     [__stack],Y
;        __addmi 2, __stack

         __negw
         __addws
	.endm

__orws	.macro
	 sax
	 ora	[__stack]
	 sax
	 ldy	#1
	 ora	[__stack],Y
       __addmi	2,__stack
	.endm

__andws	.macro
	 sax
	 and	[__stack]
	 sax
	 ldy	#1
	 and	[__stack],Y
       __addmi	2,__stack
	.endm

__eorws	.macro
	 sax
	 eor	[__stack]
	 sax
	 ldy	#1
	 eor	[__stack],Y
       __addmi	2,__stack
	.endm

__lbra	.macro
	 jmp	\1
	.endm

__lbeq	.macro
	 bne	.x\@
	 jmp	\1
.x\@
	.endm

__lbne	.macro
	 beq	.x\@
	 jmp	\1
.x\@
	.endm

