;
; LIBRARY.ASM  -  MagicKit Standard Library
; Adapted to become PceCc library
;

; TODO : optimize, please !!! this is long and slow ...
; ----
; eq
; ----
; test egality of two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X equals 0 is the two args are egals
;       else non nul
; ----
; REMARK : signed compatible
; ----

eq:
   sax
   cmp [__stack]
   sax
   bne .eq_false_add2
   __addmi       1, __stack

   cmp [__stack]
   bne .eq_false_add1

   __addmi      1, __stack
   lda #1
   rts

.eq_false_add2:
   __addmi	1,__stack
.eq_false_add1:
   __addmi      1,__stack
   cla
   clx

   rts

; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; lt
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is strictly lower than
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

ult:    ; unsigned version, slow but works
lt:     ; signed version, doesn't work well
   __addmi      1, __stack
   cmp [__stack]
   bcc .lt_false_add1 ; hibyte of the reg var < hibyte of the pushed var
   beq .lt_must_test_lobyte
   __addmi      1, __stack
   lda #1
   rts

.lt_must_test_lobyte
   __submi       1, __stack
   sax
   cmp [__stack]
   bcc .lt_false_add2       ; lobyte of the reg var < lobyte of the pushed var
   beq .lt_false_add2
   __addmi      2, __stack
   lda #1
   rts

.lt_false_add2:
   __addmi	1,__stack
.lt_false_add1:
   __addmi      1,__stack
   cla
   clx
   rts

; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; ge
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is greater or egal to
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

uge:    ; unsigned version, slow but works well
ge:     ; signed version, doesn't work well
    jsr lt
    __notw
    sax   ; it seems that the return value must be in A and not A:X
    rts

; TODO : optimize, please !!! this is slow but short :)
; ----
; ne
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is diferent from
;       the word in A:X else nul
; ----
; REMARK : signed compatible
; ----

ne:
    jsr eq
    __notw
    sax   ; it seems that the return value must be in A and not A:X
    rts


; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; gt
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is strictly greater than
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

ugt:    ; unsigned version, slow but works
gt:     ; signed version, doesn't work well
   __addmi      1, __stack
   cmp [__stack]
   beq .gt_must_test_lobyte
   bcs .gt_false_add1 ; hibyte of the reg var >= hibyte of the pushed var
   __addmi      1, __stack
   lda #1
   rts

.gt_must_test_lobyte
   __submi       1, __stack
   sax
   cmp [__stack]
   bcs .gt_false_add2       ; lobyte of the reg var >= lobyte of the pushed var
   __addmi      2, __stack
   lda #1
   rts

.gt_false_add2:
   __addmi	1,__stack
.gt_false_add1:
   __addmi      1,__stack
   cla
   clx
   rts

; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; le
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is lower or egal to
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

ule:    ; unsigned version, slow but works well
le:     ; signed version, doesn't work well
    jsr gt
    __notw
    sax   ; it seems that the return value must be in A and not A:X
    rts


; ----
; asl
; ----
; shift the pushed word left by the register word
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       shifted left by A:X
; ----
; REMARK : only the lower byte of the right operand is taken in account
;          signed compatible
; ----
asl:
   stx __temp
   __ldwp __stack
   ldy __temp
   sta __temp
   sax

.asl_begin
   asl a
   rol __temp
   dey
   bne .asl_begin

   sax
   lda __temp
   __addmi 2, __stack
   rts


; ----
; asr
; ----
; shift the pushed word right by the register word
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       shifted right by A:X
; ----
; REMARK : only the lower byte of the right operand is taken in account
;          signed compatible
; ----
asr:
   stx __temp
   __ldwp __stack
   ldy __temp
   sta __temp
   sax

.asr_begin
   cpx #$80
   ror __temp
   ror a

   dey
   bne .asr_begin

   sax
   lda __temp

   __addmi 2, __stack
   rts

; TODO : optimize .... make it available for signed stuff
; ----
; smul
; ----
; multiply the two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       multiplied by A:X
; ----
; REMARK : signed NON compatible
; ----

smul:
  __stw _bx
  __ldwp __stack
  __stw _ax
  jsr mulu16
  __addmi 2, __stack
  __ldw _cx
  rts


; TODO : optimize .... make it available for signed stuff
; ----
; sdiv
; ----
; divide the two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       divided by A:X
; ----
; REMARK : signed NON compatible
; ----


__remain  .ds 2

sdiv:
        __stw   __ptr
        __ldwp  __stack
        __stw   __temp

        lda	#0
 	sta	__remain+1
 	ldy	#16
.sdiv_begin:	asl	__temp
 	rol	__temp+1
 	rol	a
 	rol	__remain+1
 	pha
 	cmp	__ptr
 	lda	__remain+1
 	sbc	__ptr+1
	bcc	.sdiv_end
	sta	__remain+1
	pla
	sbc	__ptr
	pha
	inc	__temp
.sdiv_end:	pla
	dey
	bne	.sdiv_begin
	sta	__remain

        __addmi 2, __stack
        __ldw __temp

	rts


; TODO : optimize .... make it available for signed stuff
; ----
; smod
; ----
; give the integer remainder of the two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the remainder of the division of the
;       pushed value by A:X
; ----
; REMARK : signed NON compatible
; ----

smod:
        __stw   __ptr
        __ldwp  __stack
        __stw   __temp

        lda	#0
 	sta	__remain+1
 	ldy	#16
.smod_begin:	asl	__temp
 	rol	__temp+1
 	rol	a
 	rol	__remain+1
 	pha
 	cmp	__ptr
 	lda	__remain+1
 	sbc	__ptr+1
	bcc	.smod_end
	sta	__remain+1
	pla
	sbc	__ptr
	pha
	inc	__temp
.smod_end:	pla
	dey
	bne	.smod_begin
	sta	__remain

        __addmi 2, __stack
        __ldw __remain

	rts


; ----
; set_palette
; ----
; initialize one or more sub-palette
; ----
; IN :  _AL = index of the first sub-palette (0-31)
;       _SI = address of the color table
;       _CL = number of sub_palette to copy
; ----

set_palette:
	lda   <_al		; mulitply the sub-palette index by 16
	stz   <_ah		; and set the color index of the VCE
	asl   A
	asl   A
	asl   A
	asl   A
	rol   <_ah
	sta   color_reg
	lda   <_ah
	sta   color_reg+1
	cly
.loop_a:
	ldx   #16
.loop_b:
	lda   [_si],Y		; set a color
	iny
	sta   color_data
	lda   [_si],Y
	sta   color_data+1
	iny
	bne   .next
	inc   <_si+1
.next:  dex			; next color
	bne   .loop_b

	dec   <_cl		; next sub-palette
	bne   .loop_a
	rts


; ----
; load_bat
; ----
; transfer a bloc attribute table into VRAM
; ----
; IN :  _DI = VRAM base address
;       _DX = width of the virtual screen
;       _SI = memory location
;       _CL = nb of column to copy
;       _CH = nb of row
; ----

load_bat:
	cly
.l1:	jsr   set_write
	ldx   <_cl
.l2:	lda   [_si],Y
	sta   video_data
	iny
	lda   [_si],Y
	sta   video_data+1
	iny
	bne   .n1
	inc   <_si+1
.n1:	dex
	bne   .l2
	
	addw  <_dx,<_di
	dec   <_ch
	bne   .l1
	rts


; ----
; load_font
; ----
; transfer a 8x8 monochrome font into VRAM, slow but can be useful
; ----
; IN :  _DI = VRAM base address
;       _SI = font address in memory
;       _AL = font color (0-15)
;       _CL = number of characters to copy
; ----

load_font:
	jsr   set_write

	; copy planes 1 & 2

.copy:
	cly
.l1:	lda   [_si],Y
	tst   #$01,<_al
	bne   .p1
	cla
.p1:	sta   video_data

	lda   [_si],Y
	tst   #$02,<_al
	bne   .p2
	cla
.p2:	sta   video_data+1

	iny
	cpy   #8
	bne   .l1

	; copy planes 3 & 4

	cly
.l2:	lda   [_si],Y
	tst   #$04,<_al
	bne   .p3
	cla
.p3:	sta   video_data

	lda   [_si],Y
	tst   #$08,<_al
	bne   .p4
	cla
.p4:	sta   video_data+1

	iny
	cpy   #8
	bne   .l2

	; next character

	addw  #8,<_si
	dec   <_cl
	bne   .copy
	rts


; ----
; load_vram
; ----
; copy a block of memory to the VRAM
; ----
; IN :  _DI = VRAM location
;       _SI = memory location
;       _CX = number of words to copy
; ----

load_vram:
	jsr   set_write
	cly
.loop:	lda   [_si],Y
	sta   video_data
	iny
	lda   [_si],Y
	sta   video_data+1
	iny
	bne   .next
	inc   <_si+1
.next:	decw  <_cx
	lda   <_cl
	ora   <_ch
	bne   .loop
	rts


; ----
; set_read
; ----
; set the VDC VRAM read address
; ----
; IN :  _DI = VRAM location
; ----

set_read:
	vreg  #$01
	lda   <_di 
	sta   video_data
	lda   <_di+1
	sta   video_data+1
	vreg  #$02
	rts 


; ----
; set_write
; ----
; set the VDC VRAM write address
; ----
; IN :  _DI = VRAM location
; ----

set_write:
	vreg  #$00
	lda   <_di 
	sta   video_data
	lda   <_di+1
	sta   video_data+1
	vreg  #$02
	rts 


; ----
; HSR(xres)
; ----
; macros to calculate the value of the HSR VDC register
; ----
; IN :  xres, horizontal screen resolution
; ----

HSR	.macro
	 .if (\1 <= 272)
	  ; low res
	  .db $02
	  .db (18 - (((\1 / 8) - 1) / 2))
	 .else
	  ; high res
	  .db $03
	  .db (24 - (((\1 / 8) - 1) / 2))
	 .endif
	.endm


; ----
; HDR(xres)
; ----
; macros to calculate the value of the HDR VDC register
; ----
; IN :  xres, horizontal screen resolution
; ----

HDR	.macro
	 .db ((\1 / 8) - 1)
	 .if (\1 <= 272)
	  ; low res
	  .db (38 - ((18 - (((\1 / 8) - 1) / 2)) + (\1 / 8)))
	 .else
	  ; high res
	  .db (54 - ((24 - (((\1 / 8) - 1) / 2)) + (\1 / 8)))
	 .endif
	.endm


; ----
; init_vdc
; ----
; initialize the video controller
;  * screen mode set to 256x240
;  * display and sprites off
;  * interrupts disabled
;  * virtual screen size set to 512x256
;  * SATB set to $7F00
;  * clear the video RAM
; ----

init_vdc:
	; default screen resolution

	.ifndef _xres
_xres    .equ 256
	.endif

	; initialize the VDC registers

	stw   #.table,<_si 	; register table address in '_si'
	cly 
.l1:	lda   [_si],Y		; select the VDC register
	iny
	sta   <_vreg
	sta   video_reg
	lda   [_si],Y		; send the 16-bit data
	iny 
	sta   video_data
	lda   [_si],Y
	iny 
	sta   video_data+1
	cpy   #36		; loop if not at the end of the
	bne   .l1		; table

	; set the pixel clock frequency

	.if (_xres <= 272)
	 stz  color_ctrl
	.else
	 lda  #1
	 sta  color_ctrl
	.endif

	; clear the video RAM

	st0	#0
	st1	#0
	st2	#0

	ldx	#128
.l2:	cly
.l3:	st1	#0
	st2	#0
	dey
	bne	.l3
	dex
	bne	.l2

	rts

	; VDC register data

.table:	.db $05,$00,$00		; CR    control register
	.db $06,$00,$00		; RCR   scanline interrupt counter
	.db $07,$00,$00		; BXR   background horizontal scroll offset
	.db $08,$00,$00		; BYR        "     vertical     "      "
	.db $09,$10,$00		; MWR   size of the virtual screen
	.db $0A			; HSR +
	 HSR _xres		;     |                 [$02,$02]
	.db $0B			; HDR | display size
	 HDR _xres		;     | and synchro     [$1F,$04]
	.db $0C,$02,$0F		; VPR |
	.db $0D,$EF,$00		; VDW |
	.db $0E,$04,$00		; VCR +
	.db $0F,$10,$00		; DCR   DMA control register
	.db $13,$00,$7F		; SATB  address of the SATB


; ----
; init_psg
; ----
; initialize the sound generator.
; ----

init_psg:
	stz   psg_mainvol	; main volume to zero
	stz   psg_lfoctrl	; disable the LFO
	
	lda   #5		; set volume to zero for each channel
.clear:	sta   psg_ch            ; and disable them
	stz   psg_ctrl
	stz   psg_pan
	dec   A
	bpl   .clear

	lda   #4		; disable noise for channel 5 & 6
	sta   psg_ch
	stz   psg_noise
	lda   #5
	sta   psg_ch
	stz   psg_noise
	rts

