#include "debug.c"
#include "joy.c"

#define INIT_POS 0x2D0

main()
{

  int direction, ball_pos, ball_y, ball_x;
  int racket1, racket2, score1, score2;

  init_debug_mode();

  direction = -63;

  racket1 = 0x140;
  racket2 = 0x15F;

  ball_pos = INIT_POS;

  score1 = 0;
  score2 = 0;

  for(;;)
  {

    putdigit(0x10, ball_pos);

    ball_y = ball_pos / 0x40;
    ball_x = ball_pos - 0x40 * ball_y;

    if (ball_y <= 1)
      direction += 0x80;
    else
      if (ball_y >= 28)
        direction -= 0x80;

    if (ball_x >= 31) /* We've reached the right border */
      {
        direction -= 2;
        if ((ball_pos<racket2) ||
            (ball_pos>racket2 + 0x80)) /* The right player missed the ball */
          {
            ball_pos = INIT_POS;
            score1++;
          }
      }
    else
      if (ball_x <= 0) /* We've reached the left border */
      {
        direction +=2;
        if ((ball_pos<racket1) ||
            (ball_pos>racket1 + 0x80)) /* The left player missed the ball */
          {
            ball_pos = INIT_POS;
            score2++;
          }
      }

    ball_pos += direction;
    putdigit(0x0, ball_pos);

    putdigit(0x10, racket1);
    putdigit(0x10, racket1 + 0x40);
    putdigit(0x10, racket1 + 0x80);

    if (joy(0) & JOY_DOWN == JOY_DOWN)
     {
      if (racket1 < 0x680)
        racket1 += 0x40;
     }
    else if (joy(0) & JOY_UP == JOY_UP)
      if (racket1 >= 0x80)
        racket1 -= 0x40;

    putdigit(0x1, racket1);
    putdigit(0x1, racket1 + 0x40);
    putdigit(0x1, racket1 + 0x80);

    putdigit(0x10, racket2);
    putdigit(0x10, racket2 + 0x40);
    putdigit(0x10, racket2 + 0x80);

    if (joy(1) & JOY_DOWN == JOY_DOWN)
     {
      if (racket2 < 0x680)
        racket2 += 0x40;
     }
    else if (joy(1) & JOY_UP == JOY_UP)
      if (racket2 >= 0x80)
        racket2 -= 0x40;

    putdigit(0x2, racket2);
    putdigit(0x2, racket2 + 0x40);
    putdigit(0x2, racket2 + 0x80);

    putnumber(score1, 0x85);
    putnumber(score2, 0x9A);

    /* Here, we wait for screen refreshing so that we can see what we did */
    #asm
    vsync
    #endasm

  }

}
